import { EventEmitter } from '@angular/core';
import * as i0 from "@angular/core";
export declare class FocusClickDirective {
    disabled: boolean;
    /**
     * This directive replaces the default `click` directive and allows the user to execute
     * the `click` event by clicking the mouse **and**  by using the `enter` key on focus.
     *
     * A tabindex of `0` gets added to the host.
     *
     * @memberof FocusClickDirective
     */
    readonly focusClick: EventEmitter<void | Event>;
    private readonly tabIndex;
    private isClicked;
    private isEntered;
    static ɵfac: i0.ɵɵFactoryDeclaration<FocusClickDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FocusClickDirective, "[focusClick]", never, { "disabled": { "alias": "disabled"; "required": false; }; }, { "focusClick": "focusClick"; }, never, never, false, never>;
}
